#! /usr/bin/env python
# -*- coding: iso-8859-15 -*-

import pygtk
import gtk
import gtk.glade
import os
import subprocess
import gobject
global filename, mode, opacity, param, transduration, transitions_selected

# Internationalisation
application="gimpressive"

import gettext
if os.name == 'nt':
	# Code pour Microsoft Windows
	# Chemin du dossier locale sous windows
	win_local_path = os.path.abspath(os.path.join(os.path.pardir, 'locale'))
	# Code pour une éventuelle interface glade
	gtk.glade.bindtextdomain(application, win_local_path)
	gtk.glade.textdomain(application)
	
	# Code pour le programme python (le module 
	#local permet de déterminer la langue actuelle)
	import locale
	lang = locale.getdefaultlocale()[0][:2]
	try:
		cur_lang = gettext.translation(application, localedir=win_local_path, languages=[lang])
		cur_lang.install()
	except IOError:
    	# Si la langue locale n'est pas supportée, 
    	#on définit tout de même _()
		_ = lambda text:text
    	# S'il existe des chaînes traduisibles dans 
    	#d'autres modules, normalement gérés par
    	# cur_lang.install() ou gettext.install(), 
    	#vous devez aussi y définir _(). Exemple :sous_module._ = _
else :
	try:
		t = gettext.translation(application, 'locale')
		_ = t.ugettext
	except:
		_ = lambda x:x
		
global filename, mode, opacity, param, transduration, transitions_selected

opacity = 2 #transparence pour le mode devine 1 -> transparent 4 -> noir
mode = "" # 'vide' ou --devine
fichier="(aucun)" #'fichier à afficher'
param="" #Paramètres à passer à impressive
transduration = 1000
myImpressive= './impressive/impressive_dev.py' #Chemin vers impressive
transitions_selected=[]
myDir= os.getcwd()
execfile("src/list_transitions.py", globals())


class ImpressiveGUI:
	
	def __init__(self):
		global transduration
		builder = gtk.Builder()
		builder.add_from_file("Impressive_GUI.glade")
		self.window = builder.get_object("main_window")
		self.about = builder.get_object("apropos_window")
		self.logo = builder.get_object("bg_logo")
		self.select = builder.get_object("btn_Select_File")
		self.selectFolder = builder.get_object("btn_Choose_Folder")
		self.selectedFile = builder.get_object("label_Selected_File")
		self.list_trans = builder.get_object("scrolledwindow1")
		self.transDuration = builder.get_object("transDuration")
		self.transDuration.set_value(transduration)

		builder.connect_signals(self)
		
		#On crée et on affiche la liste des transitions
		self.modele = Ranger.recup_modele()
		self.vue = Afficher.cree_vue(self.modele)
		self.list_trans.add(self.vue)
		self.list_trans.show_all()
		
	def on_main_window_destroy(self, widget, data=None):
		gtk.main_quit()
	def on_btn_quit_clicked(self, widget, data=None):
		gtk.main_quit()
	def on_menu_quitter_activate(self, w, data=None):
		gtk.main_quit()
		
		
	def on_btn_go_clicked(self, w):
		#On envoie la présentation
		global mode, opacity
		go_presente(mode,opacity)
			
	def on_menu_presente_activate(self, w):
		#On envoie la présentation
		global mode, opacity
		go_presente(mode,opacity)
		
	def on_menu_ouvrir_activate(self, w):
		#On récupére le chemin du fichier en simulant un clic sur le bouton du selecteur
		self.select.mnemonic_activate(False) #Selectionnne le bouton
		self.window.activate_focus() #Clique
		
	def on_menu_ouvrir_Dossier_activate(self, w):
		self.selectFolder.mnemonic_activate(False) #Selectionnne le bouton
		self.window.activate_focus() #Clique
		
	def on_rb_presentation_clicked(self, w):
		global mode, opacity
		mode = ""
		opacity = 0
		
	def on_rb_Mode_Devine_clicked(self, w):
		global mode, opacity
		mode = "--devine"
		opacity = 4
	
	def on_imagemenuitem10_activate(self, w):
		
		gui.about.run()  #On affiche la boite "A Propos"
		gui.about.hide() #Et on la ferme (la boite !)
	def on_btn_Apropos_clicked(self, w):
		gui.about.run()  #On affiche la boite "A Propos"
		gui.about.hide() #Et on la ferme (la boite !)
		
	def on_btn_Select_File_clicked(self, w):
		global fichier
		wParent = None
		wFileSelection = gtk.FileChooserDialog(_("Choisir un Fichier..."),
			wParent,
			gtk.FILE_CHOOSER_ACTION_OPEN,
			(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
				gtk.STOCK_OPEN, gtk.RESPONSE_OK));
		self.filtre = gtk.FileFilter() #Filtre pour les Images et PDF
		self.filtre.set_name(_("Images"))
		self.filtre.add_mime_type("image/png")
		self.filtre.add_mime_type("image/jpeg")
		self.filtre.add_mime_type("image/gif")
		self.filtre.add_mime_type("image/tiff")
		self.filtre.add_pattern("*.png")
		self.filtre.add_pattern("*.jpg")
		self.filtre.add_pattern("*.jpeg")
		self.filtre.add_pattern("*.gif")
		self.filtre.add_pattern("*.tif")
		self.filtre.add_pattern("*.tiff")
		self.filtre.add_pattern("*.pdf")
		wFileSelection.add_filter(self.filtre)
		
		self.filtre = gtk.FileFilter() #Filtre non sélectif
		self.filtre.set_name(_("Tout"))
		self.filtre.add_pattern("*")
		wFileSelection.add_filter(self.filtre)
		
		if(wFileSelection.run() == gtk.RESPONSE_OK): #On attend la réponse
			fichier = wFileSelection.get_filename()
		else:
			fichier = "(aucun)"
		wFileSelection.destroy()
		self.selectedFile.set_label(fichier)
	
	def on_btn_Choose_Folder_clicked(self, w):
		global fichier
		wParent = None
		wFileSelection = gtk.FileChooserDialog(_("Choisir un Dossier..."),
			wParent,
			gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER,
			(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
				gtk.STOCK_OK, gtk.RESPONSE_OK));
		if(wFileSelection.run() == gtk.RESPONSE_OK): #On attend la réponse
		    fichier = wFileSelection.get_filename()
		else:
			fichier = "(aucun)"
		wFileSelection.destroy()
		self.selectedFile.set_label(fichier)
		
	def on_transDuration_value_changed(self,w):
		global transduration
		#Récupère la valeur de la durée de transition
		transduration = self.transDuration.value
		


def go_presente(mode,opacity):
	#On envoie la présentation
	global fichier, param
	if not (fichier== "(aucun)"):
		fichier = '\"'+ fichier + '\"'
		set_param(mode, opacity)
		try:
			subprocess.Popen([myImpressive + param + fichier], shell=True)
			
		except NameError:
			print ('Erreur de paramètres ou Pas de fichiers sélectionnés')
		
def set_param(m, op):
	global param, transduration
	# On construit les paramètres à passer à impressive
	transitions=liste_transitions(transitions_selected)
	if transitions=="":
		transitions="None"
	param = " "+m+ ' --transition='+transitions+' --darkness='+str(op)+" "+' --transtime='+str(int(transduration))+" "
	
def liste_transitions(liste):
	global myTransitionListe
	liste_str=""
	for l in myTransitionListe:
		if l[1] in liste:
			liste_str+=l[0]+","
	return liste_str[:-1]
	
if __name__ == "__main__":
	#Création de la liste des transitions
	Ranger = InfoModele()
	Afficher = AfficheModele()
	#Création de l'interface graphique, Lancement de la boucle gtk, 
	gui = ImpressiveGUI()
	gui.window.show()
	gtk.main()
